const encoder = new TextEncoder()
const decoder = new TextDecoder()

/**
 * String 转 Uint8Array
 */
export function encode(txt) {
  return encoder.encode(txt)
}

/**
 * Uint8Array 转 String
 */
export function decode(u8) {
  return decoder.decode(u8)
}

export function getType(val) {
  return Object.prototype.toString.call(val).slice(8, -1)
}

export function to16(n) {
  let p = ''
  if (n < 16) {
    p = '0'
  }
  return p + n.toString(16)
}

// 将16进制的文本, 转成uint8array
export function hex2u8(str) {
  if (str.length % 2) {
    throw new Error('Argument str is not a vaild hex string')
  }
  let u8 = new Uint8Array(str.length / 2)
  for (let i = 0; i <= u8.length; i++) {
    u8[i] = parseInt(str.slice(i * 2, i * 2 + 2), 16)
  }
  return u8
}

/**
 * 计算二维数组的总长度
 */
export function sum(list) {
  return list.reduce((total, it) => total + it.length, 0)
}

export function compare(buf1, buf2) {
  let s1 = buf1 + ''
  let s2 = buf2 + ''
  return s1.localeCompare(s2)
}
